# caencommon1.tcl--- common part of the control for V785(and N); V792; V775





set defaultmodulelist [list 1 2 3 4 5 6 7 8]

set modulelist {???}
set moduleindex 0

set maxmodule 8
if {![info exists adcInc]} {set adcInc 1}
if {![info exists maxadc]} {set maxadc 32}
set adcchannels 4096

set maxmodule [inform vmecontrol inquire [set modulename]count]
set modulelist {}
for {set i 1} {$i <= $maxmodule} {incr i} {lappend modulelist $i}

set module 0
if {$maxmodule} then {set module [lindex $modulelist $moduleindex]}
set adc  0

set alladcs 0
set allmodules 0


for {set i 0} {$i < $maxadc} {incr i $adcInc} {
   set w2r(THRESHOLD$i) "Threshold$i null"
   set w2r(ENABLE$i)    "Disable$i   invert"
   set adc2r(THRESHOLD$i) "Threshold\[?,??\] null"
   set adc2r(ENABLE$i)    "Disable\[?,??\] invert"
}
set w2r(GEO)        "GEO_Address null"
set w2r(GEOADDRESS) "GEO_Address null"
set w2r(INTRLEV)    "Intr_Level null"
set w2r(INTRVEC)    "Intr_Vec null"
set w2r(TERM)       "Status1.Term null"
set w2r(DREADY)     "Status1.DReady null"
set w2r(BSTATUS)    "MCST/CBLT_Ctrl null"
set w2r(EVTRIG)     "Event_Trig null"
set w2r(BSTATE)     "Status2.Bbits null"
set w2r(FASTCLEAR)  "Fast_Clear_Window null"
set w2r(EVCRESET)   "EvCounter_Reset null"
set w2r(SLIDE)      "Slide null"

set modulewidgets [list GEO FASTCLEAR]

if {$modulename == "v792"} then {
set w2r(IPED)       "Iped null"
lappend modulewidgets IPED
}

if {$modulename == "v775" || $modulename == "v878"} then {
set w2r(FSR)       "FullScaleRange null"
lappend modulewidgets FSR
}

if {$modulename == "v879" || $modulename == "v878"} then {
set w2r(CTR)       "ClearTime null"
lappend modulewidgets CTR
}

set electronicsvisible 0
set electronicsframe "[self frame-name].electronics"


loadsource common.vme

proc invert {v} {return [expr $v^1]}
proc null   {v} {return $v}


proc midas-information {text} {

    set frame [self frame-name].info

    :frame $frame :label  "Information from [self frame-title]" :transient T

    :galley G :deaf T :strings $text :font fixed :rows 50
    :show T
}


proc click-widget {w v} {
    global w2r
    global modulename module
    global allmodules

    set item $w2r($w)
    set register [first $item]
    set value [eval [second $item] $v]

    if {$allmodules == 0} then {
        write-vme-register $modulename#$module.$register $value
    } else {
        write-vme-registers $modulename#\[?,??\].$register $value
    }

    click-redisplay
}

proc click-adc-widget {w v} {
    global w2r adc2r
    global modulename module
    global alladcs allmodules

    if {$alladcs == 0} then {set item $w2r($w)} else {set item $adc2r($w)}
    set register [first $item]
    set value [eval [second $item] $v]

    if {$alladcs == 0} then {
        if {$allmodules == 0} then {
            write-vme-register $modulename#$module.$register $value
        } else {
            write-vme-registers $modulename#\[?,??\].$register $value
        }
    } else {
        if {$allmodules == 0} then {
            write-vme-registers $modulename#$module.$register $value
        } else {
            write-vme-registers $modulename#\[?,??\].$register $value
        }
    }

    click-redisplay
}

proc reset-module {} {
    global modulename module allmodules

    set register Bit_Set_1
    set data 0x80

    if {$allmodules == 0} then {
        write-vme-register $modulename#$module.$register $data
    } else {
        write-vme-registers $modulename#\[?,??\].$register $data
    }

    set register Bit_Clear_1
    set data 0x80

    if {$allmodules == 0} then {
        write-vme-register $modulename#$module.$register $data
    } else {
        write-vme-registers $modulename#\[?,??\].$register $data
    }
}

proc set-operation-mode {w v} {
    global modulename module allmodules

   switch $w {
       ONLINE    {set data 0x02}
       OVERFLOW  {set data 0x08}
       THRESHOLD {set data 0x10}
       VALC      {set data 0x20}
       SSE       {set data 0x80}
       CSS       {set data 0x400}
       EVMODE    {set data 0x1000}
       EVCMODE   {set data 0x4000}
       BIT15     {set data 0x8000}
   }

   switch $v {
       0         {set register Bit_Clear_2}
       1         {set register Bit_Set_2}
   }

    if {$allmodules == 0} then {
        write-vme-register $modulename#$module.$register $data
    } else {
        write-vme-registers $modulename#\[?,??\].$register $data
    }
}

proc do_read_buffer {} {
  global CurrentVMEServer modulename module

  set info ""
  for {set Offset 0} {$Offset < 2048} {incr Offset 64} {

     set register $modulename#$module.Output_Buffer
     set data [string trimleft [read-vme-register $register]]

     append info "\nOutput Buffer (FIFO) Offset $Offset\n\n"
     foreach word $data {
         set geo [expr $word >> 27 & 31]
         set type [expr $word >> 24 & 7]
         switch $type {
            0 {
             set event_type "data"
             set channel [expr $word >> 16 & 0x3f]
             set un [expr $word >> 13 & 1]
             set ov [expr $word >> 12 & 1]
             set adc [expr $word  & 0xfff]
             append info "[format "0x%8x    %8s   channel= %5i;  un= %3i;  ov= %3i;  adc= 0x%3x" $word $event_type $channel $un $ov $adc]"
            }
            2 {
             set event_type "header"
             set crate [expr $word >> 16 & 0xff]
             set count [expr $word >> 8 & 0x3f]
             append info "[format "0x%8x    %8s   crate= %5i;   channels= %3i" $word $event_type $crate $count]"
            }
            4 {
             set event_type "trailer"
             set counter [expr $word & 0xffffff]
             append info "[format "0x%8x    %8s   event counter= %8i" $word $event_type $counter]"
            }
            6 {
             append info "$word - assumed end of data\n"
             midas-information $info
             return
            }
            default {
             append info "$word is not a valid datum"
            }
         }
         append info "\n"
     }
  }
  append info "end of output buffer reached\n"
  midas-information $info
}

proc click-software {} {
   global modulename
   inform [set modulename]sftwre start
}

proc click-electronics {} {
#  display electronics sub frame
   global electronicsvisible electronicsframe
   if {$electronicsvisible==0} then {make-electronics} else {open-frame $electronicsframe}
   click-redisplay
}

proc click-registers {} {
   global EGreport moduletype modulename module registers_table

   if {[info procs [set moduletype]_registers] == ""} then  \
        {set-footer "No [set moduletype]_registers procedure"; return}

   [set moduletype]_registers

   clear-footer
   set KEEP $EGreport
   set EGreport -1

   set info "[set moduletype] - module $modulename#$module\n\n"

   foreach item $registers_table {
       set description [first $item]
       set register [second $item]
       set data [read-vme-register $modulename#$module.$register]
       append info "[format "%-40s %-20s" $description $data]\n"
   }

  midas-information $info

   set EGreport $KEEP
}

proc click-select-module {v} {
   global debug module maxmodule
   if {$debug} then {puts stderr "click-select-module with argument \{$v\}"}
   set module $v
   if {$module<1} then {set module 1}
   if {$module>$maxmodule} then {set module $maxmodule}
   click-redisplay
}

proc click-select-adc {v} {}

proc click-all-adcs {v} {global alladcs; set alladcs $v}

proc click-all-modules {v} {global allmodules; set allmodules $v}

proc repaint {} {}

proc redisplay-module {} {
   global w2r modulename module maxmodule
   global modulewidgets

   set maxmodule [inform vmecontrol inquire [set modulename]count]
   set menu {}
   for {set i 1} {$i <= $maxmodule} {incr i} {lappend menu $i}
   :modify MODULE-SEL :strings $menu
   :modify MODULE-NUM :max $maxmodule
   :modify MODULE-NUM :value $module

   set register EvCounter_High
   set evcounthigh [read-vme-register $modulename#$module.$register]
   set register EvCounter_Low
   set evcountlow [read-vme-register $modulename#$module.$register]

   :modify EVCOUNTER :value [expr [expr $evcounthigh << 16] + $evcountlow]

   foreach w $modulewidgets {
       set item $w2r($w)
       set register [first $item]
       set value [eval [second $item] [read-vme-register $modulename#$module.$register]]
       :modify $w :value $value
   } 

   set register "Bit_Set_2"
   set value [read-vme-register $modulename#$module.$register]

   :modify ONLINE    :value [expr $value >> 1 & 1]
   :modify OVERFLOW  :value [expr $value >> 3 & 1]
   :modify THRESHOLD :value [expr $value >> 4 & 1]
   if {$modulename == "v775" || $modulename == "v878"} then {
       :modify CSS     :value [expr $value >> 10 & 1]
   }
}

proc redisplay-adcs {} {
    global w2r
    global modulename module maxadc adcInc

    foreach W {THRESHOLD ENABLE} {
       for {set i 0} {$i < $maxadc} {incr i $adcInc} {
          set w $W$i
          set item $w2r($w)
          set register [first $item]
          set value [eval [second $item] [read-vme-register $modulename#$module.$register]]
          :modify $w :value $value
       }
    }
}

proc redisplay-electronics {} {
   global electronicsvisible
   global modulename module w2r

   if {$electronicsvisible==0} then {return}

   foreach w {GEOADDRESS INTRLEV INTRVEC TERM DREADY EVTRIG BSTATE SLIDE} {
       set item $w2r($w)
       set register [first $item]
       set value [eval [second $item] [read-vme-register $modulename#$module.$register]]
       :modify $w :value $value
   }

   set register "Bit_Set_2"
   set value [read-vme-register $modulename#$module.$register]

   :modify SSE     :value [expr $value >> 7 & 1]
   :modify EVCMODE :value [expr $value >> 14 & 1]
   :modify EVMODE  :value [expr $value >> 12 & 1]
   if {$modulename == "v775" || $modulename == "v878"} then {
       :modify VALC    :value [expr $value >> 5 & 1]
   }
   if {$modulename == "v879" || $modulename == "v878"} then {
       :modify BIT15    :value [expr $value >> 15 & 1]
   }
}

proc click-redisplay {} {
   global EGreport

   clear-footer
   set KEEP $EGreport
   set EGreport -1
   set-busy

   redisplay-module
   redisplay-adcs
   redisplay-electronics

   clear-busy
   set EGreport $KEEP
}

proc start args {
   global started EGreport modulename
   global defaultmodulelist modulelist moduleindex module
   if {$started == 0} then {
       make-frame
       EGbindings
   }
   set started 1
   open-frame

   clear-footer
   clear-busy
   set EGreport 0

   loadsource [set modulename].defn

   click-redisplay
}

proc click-quit {} {close-frame}

proc finish args {destroy-frame}


proc click arg {
   global debug actionlist
   if {$debug} then {insert-debug "click with argument \{$arg\}"}
   set f [lindex $arg 0]
   set c [lindex $arg 1]
   set w [lindex $arg 2]
   set v [lindex $arg 3]
   set i [lindex $arg 4]

   if {$c==":quit"} then {click-quit; return}
   switch -glob $w {

      MODULE-SEL      -
      MODULE-NUM {click-select-module $v}

      ALL-MODULES {click-all-modules $v}
      ALL-ADCS    {click-all-adcs $v}

      GEOADDRESS  -
      FASTCLEAR   -
      FSR         -
      CTR         -
      IPED        -
      SLIDE       {click-widget $w $v}

      EVCRESET    {click-widget $w 0}

      ONLINE      -
      OVERFLOW    -
      SSE         -
      EVMODE      -
      EVCMODE     -
      VALC        -
      CSS         -
      BIT15       -
      THRESHOLD   {set-operation-mode $w $v}

      ENABLE*     -
      THRESHOLD*  {click-adc-widget $w $v}

      ENGINEERING       {click-$v}
      REDISPLAY      {click-redisplay}

      ACTIONS  {
         set action [lindex $actionlist $i]
         eval [second $action]
      }

      default           {
           set p "click_[lowercase $w]"
           if {[info procs $p] == "$p"} then {$p} else {insert-debug "$arg"}
      }
   }
}


proc make-frame {} {
  global env actionlist
  global module maxmodule modulelist maxadc adcInc
  global modulename type

  :frame [self frame-name] :label "[self frame-title]" :show-footer T \
      :icon-image "@$env(ICONHOME)/vme_module" \
      :icon-name "[self icon-title]" :resize F

   :panel MODULE  :layout T :padx 10 :pady 10
     :layout H; :row-gap 10

     :number MODULE-NUM  :label "Module number:" :min 1 :max $maxmodule :w 5 :value $module
     :menubutton MODULE-SEL :label "select:" :strings $modulelist
     :col-gap 15
     :text GEO :label "GEO Address" :w 6 :deaf T
     :text EVCOUNTER :label "Event Counter" :w 8 :deaf T
     :hskip 50
     :checkbox ALL-MODULES :label "Act on ALL modules?"

     :next-row T
     :message M1 :label "Module Setup" :bold T
     :next-row T
     :col-gap 10

     :choice ONLINE    :label "$type controller"       :strings [list online offline]
     :choice OVERFLOW  :label "Overflow suppression" :strings [list enabled disabled]
     :choice THRESHOLD :label "Zero suppression"     :strings [list enabled disabled]
     if {$modulename == "v775" || $modulename == "v878"} then {
     :choice CSS       :label "Start/Stop"           :strings [list "Common Start" "Common Stop"]
     }
     :next-row T
     :slider FASTCLEAR :label "Fast Clear Window"  :min 0 :max 1023
     if {$modulename == "v775" || $modulename == "v878"} then {
     :slider FSR       :label "Full Scale Range"   :min 30 :max 255
     }
     if {$modulename == "v879" || $modulename == "v878"} then {
     :slider CTR       :label "Clear Time"   :min 0 :max 16384
     }
     if {$modulename == "v792"} then {
     :slider IPED       :label "Pedestal"   :min 0 :max 255
     }
  
   :panel ADC :layout T :padx 10
     :layout H; :row-gap 10; :col-gap 0
     :message M2 :label "$type Enables and Thresholds" :bold T
     :hskip 400
     :checkbox ALL-ADCS :label "Act on ALL [set type]s?"
     :next-row T

     for {set i 0} {$i < $maxadc} {} {
         :checkbox ENABLE$i    :label $i :valuex 2c 
         :slider   THRESHOLD$i :label "" :min 0 :max 255 :entry-width 3
         :hskip 10
         incr i $adcInc
         if {[expr $i / (4 * $adcInc) * (4 * $adcInc)] == $i} {:next-row T}
     }
  
   :panel CLICK :layout B :padx 10 :after FOOTER
     :layout H; :col-gap 30; :row-gap 10
      :vskip 10
      :button REDISPLAY
      :menubutton ENGINEERING :label "Engineering"  :menu [list electronics software registers]
      :button MEMRD   :label "read output buffer" :command do_read_buffer

  :show T

}

proc make-electronics {} {
  global env moduletype modulename electronicsframe electronicsvisible

 set valuex 32c

  :frame "$electronicsframe" :label "$moduletype Electronics" :resize F :transient T

   :panel P20 :layout T :padx 5 :pady 5
     :layout V; :row-gap 5; :col-gap 10

      :text GEOADDRESS :label "GEO Address" :w 8 :valuex $valuex
      :text INTRLEV    :label "Interrupt level" :w 8 :valuex $valuex
      :text INTRVEC    :label "Interrupt vector" :w 8 :valuex $valuex
      :choice TERM     :label "Control bus termination" :valuex $valuex :deaf T :strings \
  [list "incorrect" "ON" "OFF" "confused"]
      :choice DREADY   :label "Output Buffer" :valuex $valuex :deaf T :strings \
  [list "No Data Ready" "Data Ready"]
      :choice BSTATUS  :label "Board MCST/CBLT status"  :valuex $valuex  :strings \
  [list "disabled" "first" "last" "intermediate"]
      :text EVTRIG     :label "Event Trigger" :w 8 :valuex $valuex
      :choice BSTATE :label "Output Buffer" :valuex $valuex :deaf T :strings \
  [list "not empty but not full" "empty" "full" "confused"]
      :choice SSE      :label "Sliding Scale" :valuex $valuex :strings \
  [list Disabled Enabled]
      :slider SLIDE    :label "Sliding Scale DAC Constant" :valuex $valuex :min 0 :max 255
      :choice EVMODE   :label "If no accepted channels" :valuex $valuex :strings \
  [list "Write nothing" "Write null event"]
   if {$modulename == "v775" || $modulename == "v878"} then {
       :choice VALC    :label "Valid Control" :valuex $valuex :strings [list Enable Disable]
   }
   if {$modulename == "v879" || $modulename == "v878"} then {
       :choice BIT15    :label "Bit 15" :valuex $valuex :strings [list Off On]
   }
      :choice EVCMODE  :label "Event Counter Mode" :valuex $valuex :strings [list accepted all]
    :layout H
      :button EVCRESET :label "Event Counter Reset"
    :next-row T
     :button UPDATE   :label "Electronics Update"   :command redisplay-electronics
     :button RESET    :label "Module Reset"         :command reset-module
     :button SHOWREGS :label "Show register values" :command click-registers

  :show T
 set electronicsvisible 1
}
